/**
 *
 * un exemple des blocs: try-catch-finally
 *
 * @author Paul S. Wang (rf. description de cours: p.260)
 * @author Mohamed Lokbani (ajout de ArrayIndex....Exception + l'emballage!)
 *
 * @version 1.1
 */

import java.io.*;

class exo4 {
    
    public static void main (String args[]) throws IOException {
	
	FileInputStream infile=null; // un flux en entre lecture binaire. 
	File fictmp=null; // pour fichier
        boolean error=false;
        
        try {
            
	    /*
	      ouvre l'argument pass sur la ligne de commande, comme un flux
	      en entre pour une lecture binaire. 
	    */

	    infile = new FileInputStream(args[0]);

	    /*
	      ouvre un fichier temporaire "tmp_fic.txt". 
	    */

            fictmp =  new File("tmp_fic.txt");
            
	}

	/*
	  lecture dans un tableau d'un lment inexistant.
	*/

	catch (ArrayIndexOutOfBoundsException e) {
	    System.err.println("Argument inexistant!");
	    error = true;
	}

	/*
	  un fichier non trouv pour le flux mode lecture binaire. 
	*/

	catch (FileNotFoundException e) {
	    System.err.println("Erreur  l'ouverture du fichier: "+args[0]);
	    error = true;
	}

	/*
	  une erreur entre/sortie pour le fichier temporaire. 
	*/

	catch (IOException e) {
	    System.err.println("Erreur  l'ouverture du fichier: \"tmp_fic.txt\"");
	    error = true;
	}

	/*
	  une mthode finally qui vrifie ...
	*/

	finally {
	    
	    /*
	      si le flux mode lecture binaire a t ouvert, il sera ferm.
	    */
	    if (infile != null) infile.close();
	    /*
	      si le fichier a t ouvert, il sera effac.
	    */
	    if (fictmp != null) fictmp.delete();
	    /*
	      si une erreur (un catch) quelconque s'est produite, on sort
	      immdiatement du programme.
	    */
	    if (error) System.exit(1);
	}

	// tout est ok!
        System.exit(0);
        
    }
    
}
